/***************************************************************************/
/*  Output Interpretation Routines                                         */
/*                                                                         */
/*  (C) Copyright 1995,1996 Light Ray (Tobin Fricke)                       */
/*                                                                         */
/*  This file written by Light Ray - 06/08/95 04/08/96                     */
/***************************************************************************/

/* email: fricke@exo.com */

//#define demo            /* define the "demo" symbol and run for a demo.  */
#include <conio.h>;
#include <string.h>;

void output(char *str)    /* display str, do not go to next line           */

/* Output(str) takes str and outputs it to the output device[s].  In the   */
/* process, Output must evaluate any pipe codes, lvi color codes, and pipe */
/* color codes.   This is kind-of platform-dependent because it assumes    */
/* that pipe codes and digits always have the same value.. 		   */

#define CHAR_PIPE 124    /* The value of the pipe character, "|"            */
#define CHAR_ZERO 48     /* The value of "0", "1" is assumed as CHAR_ZERO+1 */
#define CHAR_LVI  28	 /* The value of the LVI sequence ID, #28	    */
#define CHAR_LVIC 29	 /* The value of the LVI color-code ID, #29         */
#define CHAR_NULL 0		 /* Rather useless, but NULL=0						*/

 {
 int i;
 i = 0;
 do {
  switch(str[i]) {
     case CHAR_LVIC:						      /* #29 signifies LVI color code  */
    textattr(str[i+1]);
    ++i;
    break;
   case CHAR_LVI:						      /* #28 signifies LVI compression */
    if ((str[i+1]=196)!=CHAR_NULL)
     { int j;
       for (j=1;j<(str[i+3]+1);++j) cprintf("%c",str[i+2]);
       i=i+3;
     } else cprintf("%c",CHAR_LVI);
     break;
   case CHAR_PIPE:						      /* #124 is pipe symbol    	   */
     if ((str[i+1]<CHAR_ZERO)+(str[i+1]>(CHAR_ZERO+10)) +
     	(str[i+2]<CHAR_ZERO)+(str[i+2]>(CHAR_ZERO+10)))  /* are next two chars in [0..9]?    */
        { cprintf("|"); }                                /* if not, print out the pipe       */
         else
        { int a;
	  a=(str[i+1]*10+str[i+2]-(10*CHAR_ZERO+CHAR_ZERO));  /* 528=ord('0')*10+ord('0') */
          if (a>15) textbackground(a-16); else textcolor(a);
	  i=i+2;}
        /* once I write the modem and emulation routines, */
        /* they will be called from here.                 */
	 break;
   default:		                       /* normal, meaningless char */
	 cprintf("%c",str[i]);                 /*    print to screen       */
	 break;
   } /* switch */
  ++i;
  }
  while(str[i]!=CHAR_NULL);		               /* while not the end of the string. */
 }

void outputln(char str[255])          /* display str, go to next line */
  {
    /* how do I append a CR LF to str? */
    strcat(str,"\n\r");
    output(str);
  }

#ifdef demo
void main() {  /* demo use of output procedure */
 int i;
 while (1)
 output("|11B|03L|09O|01R|08T|14!!!!");
}
#endif

/*

    Pipe codes explained

    Pipe codes consist of pipes (|) followed by two digits (0 through 9)
    embedded in strings.  They exist to change the color in which text
    is displayed.

---------------------------------------------------------------------------
                     black   blue  green   cyan   red magenta orange white
---------------------------------------------------------------------------
text  normal           |00    |01    |02    |03    |04    |05    |06   |07
text  high-intensity   |08    |09    |10    |11    |12    |13    |14   |15
---------------------------------------------------------------------------
back  background       |16    |17    |18    |19    |20    |21    |22   |23
---------------------------------------------------------------------------

*/